{ stdenv, fetchFromGitHub, python3Packages, yosys, symbiyosys, yices }:

python3Packages.buildPythonPackage {
  name = "nmigen";

  src = fetchFromGitHub {
    owner = "m-labs";
    repo = "nmigen";
    rev = "0ab215e5ed761a2bab07b9fe29eb8ad87eae0be9";
    sha256 = "0wwx23nldcc3gjrlz2d6d9117ghnm5c2m3jx999007s56w7vw7rz";
  };

  checkPhase = "PATH=${yosys}/bin:${symbiyosys}/bin:${yices}/bin:$PATH python -m unittest discover nmigen.test -v";

  propagatedBuildInputs = [ python3Packages.bitarray python3Packages.pyvcd python3Packages.jinja2 ];

  meta = with stdenv.lib; {
    description = "A refreshed Python toolbox for building complex digital hardware";
    homepage    = "https://m-labs.hk";
    license     = licenses.bsd2;
    maintainers = [ maintainers.sb0 ];
  };
}
